#!/bin/bash

get_random_string() {
    # $1 is used if passed in, otherwise use default
    RANDOM_STRING_LENGTH=$1
    if [ "$RANDOM_STRING_LENGTH" == "" ] ; then
        RANDOM_STRING_LENGTH="16"
    fi
    RANDOM_STRING=`openssl rand -base64 $RANDOM_STRING_LENGTH | sed 's,/,S,g' | sed 's,+,_,g' | cut -c 1-$RANDOM_STRING_LENGTH`
}

#get a random string of 16 bytes and use for keystore password
get_random_string 16

cd /var/lib/irods/geoserver/geoserver-2.3.1/etc/
rm -f /var/lib/irods/geoserver/geoserver-2.3.1/etc/keystore

openssl req -new -newkey rsa:4096 -days 365 -nodes -x509 -subj "/C=US/ST=IN/L=Lafayette/O=Purdue/CN=gabbs" -keyout ssl-cert-snakeoil.key -out ssl-cert-snakeoil.crt
openssl pkcs12 -inkey ssl-cert-snakeoil.key -in ssl-cert-snakeoil.crt -export -out ssl-cert-snakeoil.pkcs12 -password pass:$RANDOM_STRING
keytool -importkeystore -srckeystore ssl-cert-snakeoil.pkcs12 -srcstoretype PKCS12 -destkeystore keystore -srcstorepass $RANDOM_STRING -deststorepass $RANDOM_STRING

sed -i 's/KEYPASSWORD/'$RANDOM_STRING'/g' /var/lib/irods/geoserver/geoserver-2.3.1/etc/jetty-ssl.xml

