#!/bin/sh

JAVAHOME=$(type -p java|xargs readlink -f|xargs dirname|xargs dirname)

#shutdown Geoserver before modifying admin password

#check if geoserver is running first, just try to get the geoserver webpage
count=0
curl -s -o "/dev/null" http://localhost:8080/geoserver
while [ $? -ne 0 ] && [ $count -lt 3 ]
do
#still down
sleep 60
count=`expr $count + 1`
curl -s -o "/dev/null" http://localhost:8080/geoserver
done

#if we did get the Geoserver page, assume Geoserver did start
curl -s -o "/dev/null" http://localhost:8080/geoserver
if [ $? -eq 0 ]
then
	sudo JAVA_HOME=$JAVAHOME GEOSERVER_HOME=/var/lib/irods/geoserver/geoserver-2.3.1 -u irods /var/lib/irods/geoserver/geoserver-2.3.1/bin/shutdown.sh &>/dev/null &

	#wait until Geoserver has really shutdown
	count=0
	curl -s -o "/dev/null" http://localhost:8080/geoserver
	while [ $? -eq 0 ] && [ $count -lt 3 ]
	do
	#still down
	sleep 60
	count=`expr $count + 1`
	curl -s -o "/dev/null" http://localhost:8080/geoserver
	done

	#make sure it is down
	curl -s -o "/dev/null" http://localhost:8080/geoserver
	if [ $? -ne 0 ]
	then
		sed -i 's/password=".*"/password="plain:'$1'"/g' /var/lib/irods/geoserver/geoserver-2.3.1/data_dir/security/usergroup/default/users.xml

		#restart Geoserver
		sudo JAVA_HOME=$JAVAHOME GEOSERVER_HOME=/var/lib/irods/geoserver/geoserver-2.3.1 -u irods /var/lib/irods/geoserver/geoserver-2.3.1/bin/startup.sh &>/dev/null &
	
		#wait until it is running again
		count=0
		curl -s -o "/dev/null" http://localhost:8080/geoserver
		while [ $? -ne 0 ] && [ $count -lt 3 ]
		do
		#still down
		sleep 60
		count=`expr $count + 1`
		curl -s -o "/dev/null" http://localhost:8080/geoserver
		done

		#if we did get the Geoserver webpage, assume Geoserver did start
		curl -s -o "/dev/null" http://localhost:8080/geoserver
		if [ $? -eq 0 ]
		then
			sudo python /var/lib/irods/packaging/update_json.py /etc/irods/server_config.json string geoserverUser admin
			sudo python /var/lib/irods/packaging/update_json.py /etc/irods/server_config.json string geoserverPasswd $1
			sudo python /var/lib/irods/packaging/update_json.py /etc/irods/server_config.json string geoserverURL http://localhost:8080/geoserver
		else
			echo "Geoserver failed to start or took too long; not updating iRODS server config"
		fi
	else
		echo "Could not reliably shutdown Geoserver; aborting..."
	fi
else
	echo "Geoserver failed to start or took too long; not modifying admin password"
fi

